From 050e36f5d5cd7869635dd650a389133ab6a165e9 Mon Sep 17 00:00:00 2001
From: Samuel Holland <samuel@sholland.org>
Date: Sat, 5 Dec 2020 20:11:48 -0600
Subject: [PATCH 044/166] drivers: css: Drop useless STANDBYWFI polling

The cluster cannot be powered down until all cores have already been
powered down. Thus STANDBYWFI will necessarily be set for all cores.

Signed-off-by: Samuel Holland <samuel@sholland.org>
---
 drivers/css/sun50i-a64-css.c | 3 ---
 drivers/css/sun50i-h6-css.c  | 3 ---
 2 files changed, 6 deletions(-)

diff --git a/drivers/css/sun50i-a64-css.c b/drivers/css/sun50i-a64-css.c
index aff6acf..71587dc 100644
--- a/drivers/css/sun50i-a64-css.c
+++ b/drivers/css/sun50i-a64-css.c
@@ -46,9 +46,6 @@ css_set_cluster_state(uint32_t cluster UNUSED, uint32_t state)
 		for (uint32_t i = 0; i < css_get_core_count(cluster); ++i)
 			mmio_write_32(RVBA_LO_REG(i), rvba);
 	} else if (state == SCPI_CSS_OFF) {
-		/* Wait for all CPUs to be idle. */
-		mmio_poll_32(C0_CPU_STATUS_REG,
-		             C0_CPU_STATUS_REG_STANDBYWFI_MASK);
 		/* Save the power-on reset vector base address from core 0. */
 		rvba = mmio_read_32(RVBA_LO_REG(0));
 		/* Assert L2FLUSHREQ to clean the cluster L2 cache. */
diff --git a/drivers/css/sun50i-h6-css.c b/drivers/css/sun50i-h6-css.c
index 12495f1..f844f9b 100644
--- a/drivers/css/sun50i-h6-css.c
+++ b/drivers/css/sun50i-h6-css.c
@@ -30,9 +30,6 @@ css_set_cluster_state(uint32_t cluster UNUSED, uint32_t state)
 		for (uint32_t i = 0; i < css_get_core_count(cluster); ++i)
 			mmio_write_32(RVBA_LO_REG(i), rvba);
 	} else if (state == SCPI_CSS_OFF) {
-		/* Wait for all CPUs to be idle. */
-		mmio_poll_32(C0_CPU_STATUS_REG,
-		             C0_CPU_STATUS_REG_STANDBYWFI_MASK);
 		/* Save the power-on reset vector base address from core 0. */
 		rvba = mmio_read_32(RVBA_LO_REG(0));
 		/* Assert L2FLUSHREQ to clean the cluster L2 cache. */
-- 
2.30.2

